SimilarityDelegator (Lucene 3.6.2 API)
Keywords: org.apache.lucene.search.SimilarityDelegator class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class SimilarityDelegator

    java.lang.Object
      org.apache.lucene.search.Similarity
          org.apache.lucene.search.SimilarityDelegator

All Implemented Interfaces:
  Serializable

Deprecated. this class will be removed in 4.0. Please subclass `Similarity` or `DefaultSimilarity` instead.

    @Deprecated
    public class SimilarityDelegator

extends Similarity

Expert: Delegating scoring implementation. Useful in `Query.getSimilarity(Searcher)` implementations, to override only certain methods of a Searcher's Similarity implementation..

See Also:
  Serialized Form

Field Summary

Fields inherited from class org.apache.lucene.search.Similarity
`NO_DOC_ID_PROVIDED`

Constructor Summary
`SimilarityDelegator(Similarity delegee)` Deprecated. Construct a `Similarity` that delegates all methods to another.

Method Summary
`float` | `computeNorm(String fieldName, FieldInvertState state)` Deprecated. Computes the normalization value for a field, given the accumulated state of term processing for this field (see `FieldInvertState`).
`float` | `coord(int overlap, int maxOverlap)` Deprecated. Computes a score factor based on the fraction of all query terms that a document contains.
`float` | `idf(int docFreq, int numDocs)` Deprecated. Computes a score factor based on a term's document frequency (the number of documents which contain the term).
`float` | `queryNorm(float sumOfSquaredWeights)` Deprecated. Computes the normalization value for a query given the sum of the squared weights of each of the query terms.
`float` | `scorePayload(int docId, String fieldName, int start, int end, byte[] payload, int offset, int length)` Deprecated. Calculate a scoring factor based on the data in the payload.
`float` | `sloppyFreq(int distance)` Deprecated. Computes the amount of a sloppy phrase match, based on an edit distance.
`float` | `tf(float freq)` Deprecated. Computes a score factor based on a term or phrase's frequency in a document.

Methods inherited from class org.apache.lucene.search.Similarity
`decodeNorm, decodeNormValue, encodeNorm, encodeNormValue, getDefault, getNormDecoder, idfExplain, idfExplain, idfExplain, lengthNorm, setDefault, tf`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SimilarityDelegator

    public SimilarityDelegator(Similarity delegee)

  Deprecated.
  Construct a `Similarity` that delegates all methods to another.

  Parameters:
    `delegee` - the Similarity implementation to delegate to

Method Detail

### computeNorm

    public float computeNorm(String fieldName,
                             FieldInvertState state)

  Deprecated.
  Description copied from class: `Similarity`
  Computes the normalization value for a field, given the accumulated state of term processing for this field (see `FieldInvertState`).

  Implementations should calculate a float value based on the field state and then return that value.

  Matches in longer fields are less precise, so implementations of this method usually return smaller values when `state.getLength()` is large, and larger values when `state.getLength()` is small.

  Note that the return values are computed under `IndexWriter.addDocument(org.apache.lucene.document.Document)` and then stored using `Similarity.encodeNormValue(float)`. Thus they have limited precision, and documents must be re-indexed if this method is altered.

  For backward compatibility this method by default calls `Similarity.lengthNorm(String, int)` passing `FieldInvertState.getLength()` as the second argument, and then multiplies this value by `FieldInvertState.getBoost()`.

  Specified by:
    `computeNorm` in class `Similarity`
  Parameters:
    `fieldName` - field name
    `state` - current processing state for this field
  Returns:
    the calculated float norm

### queryNorm

    public float queryNorm(float sumOfSquaredWeights)

  Deprecated.
  Description copied from class: `Similarity`
  Computes the normalization value for a query given the sum of the squared weights of each of the query terms. This value is multiplied into the weight of each query term. While the classic query normalization factor is computed as 1/sqrt(sumOfSquaredWeights), other implementations might completely ignore sumOfSquaredWeights (ie return 1).

  This does not affect ranking, but the default implementation does make scores from different queries more comparable than they would be by eliminating the magnitude of the Query vector as a factor in the score.

  Specified by:
    `queryNorm` in class `Similarity`
  Parameters:
    `sumOfSquaredWeights` - the sum of the squares of query term weights
  Returns:
    a normalization factor for query weights

### tf

    public float tf(float freq)

  Deprecated.
  Description copied from class: `Similarity`
  Computes a score factor based on a term or phrase's frequency in a document. This value is multiplied by the `Similarity.idf(int, int)` factor for each term in the query and these products are then summed to form the initial score for a document.

  Terms and phrases repeated in a document indicate the topic of the document, so implementations of this method usually return larger values when `freq` is large, and smaller values when `freq` is small.

  Specified by:
    `tf` in class `Similarity`
  Parameters:
    `freq` - the frequency of a term within a document
  Returns:
    a score factor based on a term's within-document frequency

### sloppyFreq

    public float sloppyFreq(int distance)

  Deprecated.
  Description copied from class: `Similarity`
  Computes the amount of a sloppy phrase match, based on an edit distance. This value is summed for each sloppy phrase match in a document to form the frequency that is passed to `Similarity.tf(float)`.

  A phrase match with a small edit distance to a document passage more closely matches the document, so implementations of this method usually return larger values when the edit distance is small and smaller values when it is large.

  Specified by:
    `sloppyFreq` in class `Similarity`
  Parameters:
    `distance` - the edit distance of this sloppy phrase match
  Returns:
    the frequency increment for this match
  See Also:
    `PhraseQuery.setSlop(int)`

### idf

    public float idf(int docFreq,
                     int numDocs)

  Deprecated.
  Description copied from class: `Similarity`
  Computes a score factor based on a term's document frequency (the number of documents which contain the term). This value is multiplied by the `Similarity.tf(int)` factor for each term in the query and these products are then summed to form the initial score for a document.

  Terms that occur in fewer documents are better indicators of topic, so implementations of this method usually return larger values for rare terms, and smaller values for common terms.

  Specified by:
    `idf` in class `Similarity`
  Parameters:
    `docFreq` - the number of documents which contain the term
    `numDocs` - the total number of documents in the collection
  Returns:
    a score factor based on the term's document frequency

### coord

    public float coord(int overlap,
                       int maxOverlap)

  Deprecated.
  Description copied from class: `Similarity`
  Computes a score factor based on the fraction of all query terms that a document contains. This value is multiplied into scores.

  The presence of a large portion of the query terms indicates a better match with the query, so implementations of this method usually return larger values when the ratio between these parameters is large and smaller values when the ratio between them is small.

  Specified by:
    `coord` in class `Similarity`
  Parameters:
    `overlap` - the number of query terms matched in the document
    `maxOverlap` - the total number of terms in the query
  Returns:
    a score factor based on term overlap with the query

### scorePayload

    public float scorePayload(int docId,
                              String fieldName,
                              int start,
                              int end,
                              byte[] payload,
                              int offset,
                              int length)

  Deprecated.
  Description copied from class: `Similarity`
  Calculate a scoring factor based on the data in the payload. Overriding implementations are responsible for interpreting what is in the payload. Lucene makes no assumptions about what is in the byte array.

  The default implementation returns 1.

  Overrides:
    `scorePayload` in class `Similarity`
  Parameters:
    `docId` - The docId currently being scored. If this value is `Similarity.NO_DOC_ID_PROVIDED`, then it should be assumed that the PayloadQuery implementation does not provide document information
    `fieldName` - The fieldName of the term this payload belongs to
    `start` - The start position of the payload
    `end` - The end position of the payload
    `payload` - The payload byte array to be scored
    `offset` - The offset into the payload array
    `length` - The length in the array
  Returns:
    An implementation dependent float to be used as a scoring factor

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD